## test for order of output of between() and hence fixef() and ranef()
# -> factor level order or order of appearance in original data
## "since ever" plm had level order but this was changed to appearance order
# in plm 2.4-0 and changed back in rev. 1307 for plm 2.4-2.
# => factor level order makes more sense!

library(plm)
data("Crime", package = "plm")
delrows.a <- -c( 1,  2, 10, 12)
delrows.b <- -c(10, 12, 17, 18)

Crime.unbal.a <- Crime[delrows.a, ]
Crime.unbal.b <- Crime[delrows.b, ]

pCrime.unbal.a <- pdata.frame(Crime.unbal.a)
pCrime.unbal.b <- pdata.frame(Crime.unbal.b)

ix.a <- index(pCrime.unbal.a) # unclass for speed
ix.b <- index(pCrime.unbal.b) # unclass for speed


## between.default ##
options("plm.fast" = FALSE)
(bet.def.unbal.a <- between(Crime.unbal.a$crmrte, effect = ix.a[[1L]])) # individual effect
(bet.def.unbal.b <- between(Crime.unbal.b$crmrte, effect = ix.b[[1L]])) # individual effect

options("plm.fast" = FALSE)
(bet.def.plm.slow.unbal.a <- between(Crime.unbal.a$crmrte, effect = ix.a[[2L]])) # year 81 first from rev. 1307 (and plm < 2.4-0) (year 83 first in rev. 1305 (and plm 2.4-0/1))
(bet.def.plm.slow.unbal.b <- between(Crime.unbal.b$crmrte, effect = ix.b[[2L]])) # year 81 first

options("plm.fast" = TRUE) # same
